## libpqxx 7.10.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

file(READ VERSION VER_FILE_CONTENT)
string(STRIP ${VER_FILE_CONTENT} VER_FILE_CONTENT)

project(
    libpqxx
    VERSION ${VER_FILE_CONTENT}
    LANGUAGES CXX
)

if(NOT "${CMAKE_CXX_STANDARD}")
    set(CMAKE_CXX_STANDARD 17)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

option(BUILD_DOC "Build documentation" OFF)

if(NOT SKIP_BUILD_TEST)
    option(BUILD_TEST "Build all test cases" ON)
endif()

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
include(config)

add_subdirectory(src)
add_subdirectory(include)
if(BUILD_DOC)
    add_subdirectory(doc)
endif()
if(BUILD_TEST)
    add_subdirectory(test)
endif()

# installation
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/libpqxx-config-version.cmake"
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion
)
install(FILES cmake/libpqxx-config.cmake
              "${CMAKE_CURRENT_BINARY_DIR}/libpqxx-config-version.cmake"
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/libpqxx
)
install(
    EXPORT libpqxx-targets
    NAMESPACE libpqxx::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/libpqxx
)
# Build tree export
export(
    EXPORT libpqxx-targets
    NAMESPACE libpqxx::
    FILE ${CMAKE_CURRENT_BINARY_DIR}/libpqxx-targets.cmake
)
configure_file(
    cmake/libpqxx-config.cmake ${CMAKE_CURRENT_BINARY_DIR}/libpqxx-config.cmake
    COPYONLY
)
# Package generation
set(CPACK_GENERATOR TGZ)
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
include(CPack)

=== doc/CMakeLists.txt ===
find_program(HAVE_DOXYGEN doxygen)

set(PQXXVERSION "${CMAKE_PROJECT_VERSION}")
set(top_srcdir "${PROJECT_SOURCE_DIR}")
set(PQXX_ABI "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
set(PQXX_MAJOR "${PROJECT_VERSION_MAJOR}")
set(PQXX_MINOR "${PROJECT_VERSION_MINOR}")

add_custom_target(build-docs ALL
    COMMAND cp -r ${CMAKE_CURRENT_SOURCE_DIR}/../src/*.[ch]xx ../src/
    COMMAND cp -r ${CMAKE_CURRENT_SOURCE_DIR}/../include/pqxx/* ../include/pqxx/
    COMMAND doxygen ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile
    COMMENT Building documentation
)

install(
    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doxygen-html/
    DESTINATION ${CMAKE_INSTALL_DOCDIR}/html
)

=== doc/requirements.txt ===
# TODO: Pin versions.
# TODO: Do we even still need this file?
dia
sphinx-rtd-theme
myst-parser

=== src/CMakeLists.txt ===
if(NOT PostgreSQL_FOUND)
    if(POLICY CMP0074)
        cmake_policy(PUSH)
        # CMP0074 is `OLD` by `cmake_minimum_required(VERSION 3.7)`,
        # sets `NEW` to enable support CMake variable `PostgreSQL_ROOT`.
        cmake_policy(SET CMP0074 NEW)
    endif()

    find_package(PostgreSQL REQUIRED)

    if(POLICY CMP0074)
        cmake_policy(POP)
    endif()
endif()

# When setting up the include paths, mention the binary tree's include
# directory *before* the source tree's include directory.  If the source tree
# happens to contain autoconf-generated config headers, we should still prefer
# the ones in the binary tree.
macro(library_target_setup tgt)
    target_include_directories(${tgt}
    	PUBLIC
    		$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
    		$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    		$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    	PRIVATE
    		${PostgreSQL_INCLUDE_DIRS}
    )
    target_link_libraries(${tgt} PRIVATE ${PostgreSQL_LIBRARIES})
    if(WIN32)
        target_link_libraries(${tgt} PUBLIC wsock32 ws2_32)
    endif()
    install(TARGETS ${tgt} EXPORT libpqxx-targets
    	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )

    get_target_property(name ${tgt} NAME)
    get_target_property(output_name ${tgt} OUTPUT_NAME)
    if(NOT CMAKE_HOST_WIN32)
        # Create library symlink
        get_target_property(target_type ${tgt} TYPE)
        if(target_type STREQUAL "SHARED_LIBRARY")
            set(library_prefix ${CMAKE_SHARED_LIBRARY_PREFIX})
            set(library_suffix ${CMAKE_SHARED_LIBRARY_SUFFIX})
        elseif(target_type STREQUAL "STATIC_LIBRARY")
            set(library_prefix ${CMAKE_STATIC_LIBRARY_PREFIX})
            set(library_suffix ${CMAKE_STATIC_LIBRARY_SUFFIX})
        endif()

        list(APPEND noop_command "${CMAKE_COMMAND}" "-E" "true")
        list(APPEND create_symlink_command "${CMAKE_COMMAND}" "-E" "create_symlink" "${library_prefix}${output_name}${library_suffix}" "${library_prefix}${name}${library_suffix}")
        # `add_custom_command()` does nothing if the `OUTPUT_NAME` and `NAME`
        # properties are equal, otherwise it creates library symlink.
        add_custom_command(TARGET ${tgt} POST_BUILD
            COMMAND "$<IF:$<STREQUAL:${name},${output_name}>,${noop_command},${create_symlink_command}>"
            VERBATIM
            COMMAND_EXPAND_LISTS
        )
        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${library_prefix}${name}${library_suffix}
            DESTINATION ${CMAKE_INSTALL_LIBDIR}
        )
    endif()
endmacro()

file(GLOB CXX_SOURCES *.cxx)

add_library(pqxx ${CXX_SOURCES})
add_library(libpqxx::pqxx ALIAS pqxx)

get_target_property(pqxx_target_type pqxx TYPE)
if(pqxx_target_type STREQUAL "SHARED_LIBRARY")
    target_compile_definitions(pqxx PUBLIC PQXX_SHARED)
endif()

set_target_properties(
    pqxx PROPERTIES
    OUTPUT_NAME $<IF:$<PLATFORM_ID:Windows>,pqxx,pqxx-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}>
)
library_target_setup(pqxx)

# install pkg-config file
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix \${prefix})
set(libdir "\${prefix}/${CMAKE_INSTALL_LIBDIR}")
set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
set(VERSION ${PROJECT_VERSION})
configure_file(${PROJECT_SOURCE_DIR}/libpqxx.pc.in ${PROJECT_BINARY_DIR}/libpqxx.pc)
install(FILES ${PROJECT_BINARY_DIR}/libpqxx.pc
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== test/CMakeLists.txt ===
enable_testing()

if(NOT PostgreSQL_FOUND)
    find_package(PostgreSQL REQUIRED)
endif()

file(GLOB TEST_SOURCES test*.cxx unit/test_*.cxx runner.cxx)

add_executable(runner ${TEST_SOURCES})
target_link_libraries(runner PUBLIC pqxx)
target_include_directories(runner PRIVATE ${PostgreSQL_INCLUDE_DIRS})
add_test(
    NAME runner
    WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    COMMAND runner
)

if(INSTALL_TEST)
    install(
        PROGRAMS runner
        TYPE BIN
        RENAME libpqxx-test-runner
    )
endif()

=== debian/changelog ===
libpqxx (7.10.0-2) unstable; urgency=medium

  * Upload to unstable after transition ACK.

 -- Teus Benschop <teusbenschop@debian.org>  Thu, 23 Jan 2025 17:15:05 +0100

libpqxx (7.10.0-1) experimental; urgency=medium

  [ Maarten van Geijn <debian@mvangeijn.nl> ]
  * New upstream version 7.10.0
  * Maarten did all the work.
  * Teus did the sponsoring.
  * Upload to experimental to start the lib transition

 -- Teus Benschop <teusbenschop@debian.org>  Tue, 07 Jan 2025 18:35:40 +0100

=== debian/control ===
Source: libpqxx
Section: libs
Priority: optional
Maintainer: Debian PostgreSQL team <team+postgresql@tracker.debian.org>
Uploaders: Teus Benschop <teusbenschop@debian.org>,
           Maarten van Geijn <debian@mvangeijn.nl>
Build-Depends: debhelper-compat (= 13),
               libpq-dev (>= 8.0.3),
               chrpath,
               libtool,
               python3-all,
               autoconf-archive
Build-Depends-Indep: doxygen,
                     xmlto,
                     graphviz
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/debian/libpqxx.git
Vcs-Browser: https://salsa.debian.org/debian/libpqxx
Homepage: https://github.com/jtv/libpqxx/
Rules-Requires-Root: no

Package: libpqxx-dev
Section: libdevel
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         pkgconf,
         libpq-dev (>= 8.0.3-1),
         libpqxx-7.10 (= ${binary:Version})
Suggests: libpqxx-doc
Description: C++ library to connect to PostgreSQL (development files)
 C++ library to enable user programs to communicate with
 the PostgreSQL database back-end.
 .
 This package contains header files for linking against libpqxx. Obsoletes
 the libpqpp-dev package.

Package: libpqxx-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
Suggests: libpqxx-dev (>= ${binary:Version})
Description: C++ library to connect to PostgreSQL (documentation)
 C++ library to enable user programs to communicate with
 the PostgreSQL database back-end.
 .
 This package contains documentation and examples.

Package: libpqxx-7.10
Replaces: libpqxx-7.10
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: C++ library to connect to PostgreSQL
 C++ library to enable user programs to communicate with
 the PostgreSQL database back-end. The database back-end can
 be local or it may be on another machine, accessed via
 TCP/IP. This package obsoletes the libpqpp package.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

# Full hardening ON
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# Fixing reproducible builds
LC_ALL := C.UTF-8
export LC_ALL

# This has to be exported to make some magic below work.
export DH_OPTIONS

export LIBRARY_VERSION=7.10

%:
	dh $@

override_dh_auto_configure-arch:
	dh_auto_configure -- --enable-shared

override_dh_auto_configure-indep:
	dh_auto_configure -- --enable-shared

override_dh_auto_build-indep:
	cd $(CURDIR)/doc/ && doxygen
	find -type f -iname "*.md5" -delete

override_dh_auto_test:
	@echo "not doing any testing"

override_dh_install:
	## cleaning up dependency_libs filed in *.la files
	sed -i "/dependency_libs/ s/'.*'/''/" `find . -name '*.la'`
	dh_install

override_dh_makeshlibs:
	dh_makeshlibs -- -v$(LIBRARY_VERSION)

=== debian/watch ===
version=4
#opts=filenamemangle=s/(?:.*)?v?(\d[\d\.]*)\.tar\.gz/libpqxx-$1.tar.gz/,\
#  pgpsigurlmangle=s/archive\/(.*)\.tar\.gz/releases\/download\/$1\/$1\.tar\.gz\.asc/,\
#	repacksuffix=+dfsg1,uversionmangle=s/-.*$//,dversionmangle=s/[-.+~]?(git|snapshot|repack|dfsg)(.*)$//i \
#  https://github.com/jtv/libpqxx/releases .*/v?(\d.*)\.tar\.gz

opts="filenamemangle=s/(?:.*)?v?(\d[\d\.]*)\.tar\.gz/libpqxx-$1.tar.gz/,\
	repacksuffix=+dfsg1,uversionmangle=s/-.*$//,dversionmangle=s/[-.+~]?(git|snapshot|repack|dfsg)(.*)$//i" \
  https://github.com/jtv/libpqxx/tags .*/v?(\d.*)\.tar\.gz
